local Knapp = {}
local Knappmt = { __index = Knapp }
local font = love.graphics.newFont( 24 )


white = {255, 255,255}
red = {255, 0, 0,128}
blue = {64, 64, 255,128}
green = {0, 255, 0}


template = {}
template.color = red
template.color_pressed = green
template.color_text = white
template.color_over = blue



Knapp.lista = {}

function Knapp:new(str, x, y, cal, s, p)
	local font = love.graphics.newFont( s )
	local fh = font:getHeight( )
	local fw = font:getWidth(str)
	local p = p or 1
	
	
	local knapp = setmetatable(
		{
		str = str or "",
		x=x or 0,
		y=y or 0,
		b=b or fh*p/2,
		w=w or fw + fh*p,
		h=h or fh + fh*p,
		font = font,
		cal = cal,
		font = font
		},
    Knappmt
	)
	
	table.insert(self.lista, knapp)
end



	
function Knapp:load()
	for i, k in ipairs(self.lista) do
	end

end

function Knapp:check(x,y)

	for i, k in ipairs(self.lista) do

	if x > k.x and y > k.y and x < k.x+k.w and y < k.y+k.h then
		k.col = true
	else
		k.col = false
	end
	
	end
end


function Knapp:lastX()
	return self.lista[#self.lista].x
end

function Knapp:lastY()
	return self.lista[#self.lista].y+self.lista[#self.lista].h
end

--****************************************************************************
function Knapp:update(dt)
	for i, k in ipairs(self.lista) do
--[[	if k.col then
	if k.cal then
		k.cal()
	end
	end--]]
	end
end
--****************************************************************************


function Knapp:draw()

	for i, k in ipairs(self.lista) do

	love.graphics.setFont(k.font);
	if k.col then

		love.graphics.setColor(template.color_over)
		love.graphics.rectangle( "fill", k.x , k.y, k.w, k.h)
				love.graphics.setColor(white)
		love.graphics.rectangle( "line", k.x , k.y, k.w, k.h)

		
		if k.pressed then
				love.graphics.setColor(template.color_pressed)
				love.graphics.rectangle( "line", k.x , k.y, k.w, k.h)
		end
	else
		love.graphics.setColor(template.color)
		love.graphics.rectangle( "fill", k.x , k.y, k.w, k.h)
				love.graphics.setColor(white)
		love.graphics.rectangle( "line", k.x , k.y, k.w, k.h)
	end

	love.graphics.setColor(template.color_text)
	love.graphics.print( k.str, k.x+k.b, k.y + k.b)
	
	end

end  

--****************************************************************************



function Knapp:keyreleased(key)
	
end

function Knapp:mousereleased(x, y, button)
	for i, k in ipairs(self.lista) do
		k.pressed = false
	end
end

function Knapp:keypressed(key, code)

end

function Knapp:mousepressed(x, y, button)
	for i, k in ipairs(self.lista) do
		k.pressed = true
		if k.col then
			if k.cal then
				k.cal()
			end
		end
	end
end

return Knapp