local Object = {}
local Objectmt = { __index = Object }


function imgobj(file)
	return {x = 0,y = 0,image = {file = file, x=0,y=0,r=0,sx=1,sy=1,ox=0,oy=0,kx=0,ky=0,}} 
end


function newObject(x, y, id, obj)
	local object = setmetatable(
		{
		x=x or 0,
		y=y or 0,
		id=id or 0,
		obj = obj,
		},
    Objectmt
	)
	return object
end


function Object:update(dt)
	
end

function Object:draw(x, y)
	
	x = x or 0
	y = y or 0
	
	if self.obj.color then
		love.graphics.setColor( self.obj.color.r, self.obj.color.g, self.obj.color.b, self.obj.color.a)
	end
	
	if self.obj.rectangle then
		love.graphics.rectangle( self.obj.rectangle.m, x+self.x + self.obj.x + self.obj.rectangle.x, y+self.y + self.obj.y + self.obj.rectangle.y, self.obj.rectangle.w, self.obj.rectangle.h)
	end
	
	
	
	if self.obj.circle then
		love.graphics.circle( self.obj.circle.m, x+self.x + self.obj.x + self.obj.circle.x, y+self.y + self.obj.y + self.obj.circle.y, self.obj.circle.r, self.obj.circle.s)
	end
	--]]


love.graphics.setColor( 255, 255, 255, 255)
	
	if self.obj.image then
			love.graphics.draw( 
		images[self.obj.image.file],
		x+self.x+self.obj.x, 
		y+self.y+self.obj.y,
		self.obj.r, 
		self.obj.sx,
		self.obj.sy,
		self.obj.ox,
		self.obj.oy,
		self.obj.kx,
		self.obj.ky )

	end

end

local coll = {}

snr = 0
rec = {}

function Object:addCol()

	
	if self.obj.collision then
		if self.obj.rectangle then
		snr = snr+1  

			rec = Collider:addRectangle(
			self.x+self.obj.x+self.obj.rectangle.x, 
			self.y+self.obj.y+self.obj.rectangle.y, 
			self.obj.rectangle.w,
			self.obj.rectangle.h)
			
			rec.name = "rectange"
			
			table.insert(coll, rec)
			
			
			print("added col at")
			print(self.x+self.obj.x+self.obj.rectangle.x, self.y+self.obj.y+self.obj.rectangle.y)
		end
	end
	
	
	Collider:addToGroup("platforms", rec)
end

	

local Scroll = {}
local Scrollmt = { __index = Scroll }


--********** Scroll *************--

function newScroll(file)


	local scroll = setmetatable(
		{
		file = file,
		list = {},
		position = 1,
		selected = {},
		action = {}
		},
    Scrollmt
	)
	return scroll
end	

function Scroll:save()
	success = love.filesystem.write(self.file, "return " .. Tserial.pack(self.list, true, true))
	print("Saved object list")
end

function Scroll:load()
	self.list = love.filesystem.load(self.file )()
	print("Loaded object list")
	--self.selected = newObject(0, 0, 0, self.list[self.position])
	self.action()
end

function Scroll:add(obj)
	table.insert(self.list, obj)
end
	
function Scroll:up()
	self.position = self.position + 1
	if self.position >= #self.list+1 then 
		self.position = 1
	end
	
	--self.selected = newObject(0, 0, 0, self.list[self.position])
	self.action()
	print(self.position)
	
end
	
function Scroll:down()
	self.position = self.position - 1
	if self.position <= 0 then 
		self.position = #self.list
	end
	
	self.action()
	--self.selected = newObject(0, 0, 0, self.list[self.position])
	print(self.position)
end


function Scroll:obj(pos)
	pos = pos or self.position
	return self.list[self.position]
end

	
function Scroll:draw(x,y)
if self.selected then
	self.selected:draw(x,y)
end
end	

	
		
--********** World *************--
local World = {}

local Worldmt = { __index = World }

function newWorld()

	
	
	local world = setmetatable(
		{
		foreground = {},
		objects = {},
		background = {},
		},
    Worldmt
	)
	return world
end



function World:addcol()
	for i, obj in ipairs(self.objects) do
		obj:addCol()
	end
end


function World:add(x, y, id, obj)
	print("added object")
	
	local selected = newObject(x, y, id, obj)
	--
	table.insert(self.objects, selected)
end

function World:addblock(x, y, id, load)
	print("added block object")
	
	for i, o in ipairs(load) do
		print("nr= " .. i)
		local selected = newObject(x+o.x, y+o.y, o.id, o.obj)
		table.insert(self.objects, selected)
	end
end



function World:update(dt)
	for i, obj in ipairs(self.objects) do
	obj:update(dt)
	--	obj.y = obj.y+100*dt
	end
end


function World:draw()
	for i, obj in ipairs(self.objects) do
		obj:draw()
		--obj.col.draw()
	end
		
	for i, obj in pairs(coll) do
	love.graphics.setColor( 200, 0, 0, 255)
	obj:draw()
	end
	
end

function World:save(file)

--	print(Tserial.pack(self.objects, true, true))
	local file = file or "world1.lua"
	local success = love.filesystem.write(file, "return " .. Tserial.pack(self.objects, true, true))
	print("saveing to " .. file )
end

function World:load()
	print("**********loading**********")
	local chunk = love.filesystem.load("obj1.lua" ) -- load the chunk
	
	local load = chunk()
	
	--show(load[1])
	--local success = love.filesystem.write("obj2.lua", "return " .. Tserial.pack(load[1], true, true))
	
	self.objects = {}
	for i, o in ipairs(load) do
		print("nr= " .. i)
		local selected = newObject(o.x, o.y, o.id, o.obj)
		table.insert(self.objects, selected)
	end
end


--********** Grid *************--
local Grid = {}

local Gridmt = { __index = Grid }

function newGrid(w,h,start_x,start_y)

	
	
	local grid = setmetatable(
		{
		steps = {0, 8, 16, 32, 64, 128},
		x=0,
		y=0,
		nr=3,
		start_x=start_x or 0,
		start_y=start_y or 0,
		w=w,
		h=h,
		},
    Gridmt
	)
	return grid
end

function Grid:snap(x,y)

	if self.steps[self.nr] == 0 then
		return x, y
	end
	self.x = x - math.fmod(x - self.start_x,self.steps[self.nr])
	self.y = y - math.fmod(y - self.start_y,self.steps[self.nr])
	
	return self.x, self.y
end


function Grid:up()
	self.nr = self.nr + 1
	
	if self.nr >= #self.steps+1 then 
		self.nr = 1
	end
end

function Grid:down()
	self.nr = self.nr - 1
	
	if self.nr <= 0 then 
		self.nr = #self.steps
	end
end


function Grid:draw(w,h)
	love.graphics.setColor(255,255,255, 64)
	
		if self.steps[self.nr] == 0 then
	
	else

		for x = self.start_x, self.w, self.steps[self.nr] do
			love.graphics.line( x, self.start_y, x, self.h )
		end

		for y = self.start_y, self.h , self.steps[self.nr] do
			love.graphics.line( self.start_x, y, self.w , y )
		end
	end
end

















